/* $Id: attrib.cpp,v 1.5 2001/09/21 09:44:33 zellerin Exp $
 *
 * (Disp_Attr0) vypis cursoru v mode 0
 * (Disp_Attr1) vypis dat z cursoru v mode 1
 * (Disp_Attrname1) vypis jmen atributu v cursoru v mode 1
 * (Disp_Attrtype1) vypis typu atributu v cursoru v mode 1
 */
#include <string.h>
#include <stdio.h>
#include <wbkernel.h>
#include <general.h>

#include "attrib.h"
#include "options.h"
#include "wbcl.h"

CFNC void convert2string(const void * val, int tp, char * txt, int prez, t_specif specif);

tattrib attr_count;  //kolikaty atribut zobrazuju
tcurstab cursor_num; //cislo prave otevreneho kurzoru
trecnum rec_num;     //kolikaty zaznam zobrazuju

/* The function is called as a callback from Enum_attributes. */
int Disp_Attr0(char * attrname, uns8 attrtype, uns8 attrmult, t_specif specif, void *unused)
{
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (disp_attrname)
    {
      printf("%s ", attrname);
      for (int i=0; 32-i>(int)strlen(attrname); i++)
        printf(" ");
    }
    if (attrtype==ATT_INT32)
    {  
      int attr_int;
      if (disp_attrtype)
        printf("Integer   ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_int))
        if (attr_int != NONEINTEGER)    
          printf("%d", attr_int);
    }
    else if (attrtype==ATT_INT16)
    {
      sig16 attr_short;
      if (disp_attrtype)
        printf("Short     ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_short))
        if (attr_short != NONESHORT)
	  printf("%d", attr_short);
    }
    else if (attrtype==ATT_BOOLEAN)
    {
      uns8 attr_bool;
      if (disp_attrtype)
        printf("Bool      ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_bool))
        if (attr_bool != NONEBOOLEAN)
	  if (attr_bool == TRUE)
            printf("TRUE");
	  else
            printf("FALSE");
    }
    else if (attrtype==ATT_CHAR)
    {
      char attr_char;
      if (disp_attrtype)
        printf("Char      ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_char))
        if (attr_char != NONECHAR)
	{
	  printf("%c", attr_char);
	  if (disp_descr)
	    printf(",[%d]", attr_char);
	}
    }
    else if (attrtype==ATT_FLOAT)
    {
      float attr_real;
      if (disp_attrtype)
        printf("Real      ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_real))
        if (attr_real != NONEREAL)
	  printf("%f", attr_real);
    }
    else if (attrtype==ATT_STRING ) //|| attrtype==ATT_CSSTRING || attrtype==ATT_CSISTRING)
    {
      char attr_str[0x2000];
      *attr_str=0;
      if (disp_attrtype)
      {
        if (attrtype==ATT_STRING)
          printf("String    ");
#if 0
        else if (attrtype==ATT_CSSTRING)
          printf("CSString  ");
        else if (attrtype==ATT_CSISTRING)
          printf("CSIString ");
#endif
      }
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, attr_str)){
	      char buffer[0x1000];
        if (*attr_str != 0){
		convert2string(attr_str, attrtype, buffer, 102, specif);
	  printf("%s", buffer);
	} else printf("null");
      }
    }
    else if (attrtype==ATT_TEXT)
    {
      char attr_text[65536];
      uns32 datasize;
      if (disp_attrtype)
        printf("Text      ");
      uns32 attr_len;
      if (disp_descr)
        if (!cd_Read_len(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	    printf("%ld bytes", attr_len);
      if (disp_textl > 65536)
        disp_textl = 65536;
      if (attr_len > 0 && disp_textl > 0)
        if (!cd_Read_var(cdp, cursor_num, rec_num, attr_count, NOINDEX, 0, disp_textl, attr_text, &datasize))
          if (datasize > 0)
	  {
	    if ((int)attr_len > disp_textl-1) attr_text[disp_textl-1]=0;
	    printf("\n%s", attr_text);
	  }
    }
    else if (attrtype==ATT_MONEY)
    {
      monstr attr_money;
      if (disp_attrtype)
        printf("Money     ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_money))
        if (money2real(&attr_money)!=NONEREAL)
	  printf("%.2f", money2real(&attr_money));
    }
    else if (attrtype==ATT_DATE)
    {
      uns32 attr_date;
      if (disp_attrtype)
        printf("Date      ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_date))
        if (attr_date != NONEDATE)
	  printf("%d.%d.%d", Day(attr_date), Month(attr_date), Year(attr_date));
    }
    else if (attrtype==ATT_TIME)
    {
      uns32 attr_time;
      if (disp_attrtype)
        printf("Time      ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_time))
        if (attr_time != NONETIME)
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
    }
    else if (attrtype==ATT_TIMESTAMP)
    {
      uns32 attr_ts;
      uns32 attr_time;
      uns32 attr_date;
      if (disp_attrtype)
        printf("Timestamp ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_ts))
        if (attr_ts != NONETIME)
	{
	  attr_date = timestamp2date(attr_ts);
	  attr_time = timestamp2time(attr_ts);
	  printf("%d.%d.%d - ", Day(attr_date), Month(attr_date), Year(attr_date));
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
	}
    }
    else if (attrtype==ATT_BINARY)
    {
      uns8 attr_bin[256];
      t_specif attr_binl;
      tattrib attrnum;
      uns8 attrtype;
      uns8 attrmult;
      if (disp_attrtype)
        printf("Binary    ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, attr_bin))
        if (cd_Attribute_info_ex(cdp, cursor_num, attrname, &attrnum, &attrtype, &attrmult, &attr_binl))
	{
	  if (attr_binl.length>16) 
	    attr_binl.length=16;
	  for (int i=0; i<attr_binl.length; i++)
	    printf("%.2X", attr_bin[i]);
	}
    }
    else if (attrtype==ATT_RASTER)
    {
      if (disp_attrtype)
        printf("Raster    ");
      uns32 attr_len;
      if (disp_descr)
        if (!cd_Read_len(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%ld bytes", attr_len);
    }
    else if (attrtype==ATT_NOSPEC)
    {
      if (disp_attrtype)
        printf("Nospec    ");
      uns32 attr_len;
      if (disp_descr)
        if (!cd_Read_len(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%ld bytes", attr_len);
    }
/* vzor pro dlsi typy
    else if (attrtype==ATT_)
    {
       attr_;
      if (disp_attrtype)
        printf(" ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_))
        if (attr_ != NONE)
	  printf("%d", attr_);
    }
    */
    printf("\n");
  }
  return TRUE;
}

int Disp_Attr1(char * attrname, uns8 attrtype, uns8 attrmult, t_specif specif, void * unused)
{ 
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (attrtype==ATT_INT32)
    {  
      int attr_int;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_int))
        if (attr_int != NONEINTEGER)    
          printf("%d", attr_int);
    }
    else if (attrtype==ATT_INT16)
    {
      sig16 attr_short;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_short))
        if (attr_short != NONESHORT)
	  printf("%d", attr_short);
    }
    else if (attrtype==ATT_BOOLEAN)
    {
      uns8 attr_bool;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_bool))
        if (attr_bool != NONEBOOLEAN)
	  if (attr_bool == TRUE)
            printf("TRUE");
	  else
            printf("FALSE");
    }
    else if (attrtype==ATT_CHAR)
    {
      char attr_char;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_char))
        if (attr_char != NONECHAR)
	{
	  printf("%c", attr_char);
	  if (disp_descr)
	    printf(",[%d]", attr_char);
	}
    }
    else if (attrtype==ATT_FLOAT)
    {
      float attr_real;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_real))
        if (attr_real != NONEREAL)
	  printf("%f", attr_real);
    }
    else if (attrtype==ATT_STRING) // || attrtype==ATT_CSSTRING || attrtype==ATT_CSISTRING)
    {
      char attr_str[256];
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, attr_str)){
	      char buffer[0x1000];
		convert2string(attr_str, attrtype, buffer, -2, specif);
		if (*buffer != 0)
			printf("%s", buffer);
		else printf("(null)");
	}
    }
    else if (attrtype==ATT_TEXT)
    {
      char attr_text[65536];
      uns32 datasize;
      uns32 attr_len;
      if (disp_descr)
        if (!cd_Read_len(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	    printf("%ld bytes", attr_len);
      if (disp_textl > 65536)
        disp_textl = 65536;
      if (attr_len > 0 && disp_textl > 0)
        if (!cd_Read_var(cdp, cursor_num, rec_num, attr_count, NOINDEX, 0, disp_textl, attr_text, &datasize))
          if (datasize > 0)
	  {
	    if ((int)attr_len > disp_textl-1) attr_text[disp_textl-1]=0;
	    printf("%s", attr_text);
	  }
    }
    else if (attrtype==ATT_MONEY)
    {
      monstr attr_money;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_money))
        if (money2real(&attr_money)!=NONEREAL)
	  printf("%.2f", money2real(&attr_money));
    }
    else if (attrtype==ATT_DATE)
    {
      uns32 attr_date;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_date))
        if (attr_date != NONEDATE)
	  printf("%d.%d.%d", Day(attr_date), Month(attr_date), Year(attr_date));
    }
    else if (attrtype==ATT_TIME)
    {
      uns32 attr_time;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_time))
        if (attr_time != NONETIME)
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
    }
    else if (attrtype==ATT_TIMESTAMP)
    {
      uns32 attr_ts;
      uns32 attr_time;
      uns32 attr_date;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_ts))
        if (attr_ts != NONETIME)
	{
	  attr_date = timestamp2date(attr_ts);
	  attr_time = timestamp2time(attr_ts);
	  printf("%d.%d.%d - ", Day(attr_date), Month(attr_date), Year(attr_date));
	  printf("%d:%d:%d", Hours(attr_time), Minutes(attr_time), Seconds(attr_time));
	}
    }
    else if (attrtype==ATT_BINARY)
    {
      uns8 attr_bin[256];
      uns16 attr_binl;
      t_specif attr_specif;
      tattrib attrnum;
      uns8 attrtype;
      uns8 attrmult;
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, attr_bin))
        if (cd_Attribute_info_ex(cdp, cursor_num, attrname, &attrnum, &attrtype, &attrmult, &attr_specif))
	{
	  attr_binl=attr_specif.length;
	  if (attr_binl>16) 
	    attr_binl=16;
	  for (int i=0; i<attr_binl; i++)
	    printf("%.2X", attr_bin[i]);
	}
    }
    else if (attrtype==ATT_RASTER)
    {
      uns32 attr_len;
      if (disp_descr)
        if (!cd_Read_len(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%ld bytes", attr_len);
    }
    else if (attrtype==ATT_NOSPEC)
    {
      uns32 attr_len;
      if (disp_descr)
        if (!cd_Read_len(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_len))
	  printf("%ld bytes", attr_len);
    }
/* vzor pro dlsi typy
    else if (attrtype==ATT_)
    {
       attr_;
      if (disp_attrtype)
        printf(" ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_))
        if (attr_ != NONE)
	  printf("%d", attr_);
    }
    */
    printf(disp_attrsep);
  }
  return TRUE;
}

int Disp_Attrname1( char * attrname, uns8 attrtype, uns8 attrmult, t_specif attrspecif, void * unused)
{
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (disp_attrname)
    {
      printf("%s ", attrname);
//      for (int i=0; 32-i>strlen(attrname); i++)
//        printf(" ");
    }
    printf(", ");
  }
  return TRUE;
}

int Disp_Attrtype1( char * attrname, uns8 attrtype, uns8 attrmult, t_specif attrspecif, void * unused)
{
  attr_count++;
  if (strncmp(attrname,"_W5_",4))
  {
    if (attrtype==ATT_INT32)
    {  
      if (disp_attrtype)
        printf("Integer");
    }
    else if (attrtype==ATT_INT16)
    {
      if (disp_attrtype)
        printf("Short");
    }
    else if (attrtype==ATT_BOOLEAN)
    {
      if (disp_attrtype)
        printf("Bool");
    }
    else if (attrtype==ATT_CHAR)
    {
      if (disp_attrtype)
        printf("Char");
    }
    else if (attrtype==ATT_FLOAT)
    {
      if (disp_attrtype)
        printf("Real");
    }
    else if (attrtype==ATT_STRING)// || attrtype==ATT_CSSTRING || attrtype==ATT_CSISTRING)
    {
      if (disp_attrtype)
      {
        if (attrtype==ATT_STRING)
          printf("String");
#if 0
        else if (attrtype==ATT_CSSTRING)
          printf("CSString");
        else if (attrtype==ATT_CSISTRING)
          printf("CSIString");
#endif
      }
    }
    else if (attrtype==ATT_TEXT)
    {
      if (disp_attrtype)
        printf("Text");
    }
    else if (attrtype==ATT_MONEY)
    {
      if (disp_attrtype)
        printf("Money");
    }
    else if (attrtype==ATT_DATE)
    {
      if (disp_attrtype)
        printf("Date");
    }
    else if (attrtype==ATT_TIME)
    {
      if (disp_attrtype)
        printf("Time");
    }
    else if (attrtype==ATT_TIMESTAMP)
    {
      if (disp_attrtype)
        printf("Timestamp");
    }
    else if (attrtype==ATT_BINARY)
    {
      if (disp_attrtype)
        printf("Binary");
    }
    else if (attrtype==ATT_RASTER)
    {
      if (disp_attrtype)
        printf("Raster");
    }
    else if (attrtype==ATT_NOSPEC)
    {
      if (disp_attrtype)
        printf("Nospec");
    }
/* vzor pro dlsi typy
    else if (attrtype==ATT_)
    {
       attr_;
      if (disp_attrtype)
        printf(" ");
      if (!cd_Read_ind(cdp, cursor_num, rec_num, attr_count, NOINDEX, &attr_))
        if (attr_ != NONE)
	  printf("%d", attr_);
    }
    */
    printf(", ");
  }
  return TRUE;
}

#define CHARSET_COUNT 2
class wbcharset_t
{ uns8 code;  // internal representation of charset
#ifdef LINUX
	static charset_t *code_table;
	static const char* code_name[CHARSET_COUNT];
 public:
	operator charset_t (){return code_table[code];}
	operator const char *(){return code_name[code];}
	wbcharset_t(charset_t){};
#else // WINS
	static DWORD lcid_table[CHARSET_COUNT];
	static int   cp_table  [CHARSET_COUNT];
 public:
  DWORD lcid(void) const { return lcid_table[code]; }
  DWORD cp  (void) const { return   cp_table[code]; }
#endif
	wbcharset_t(uns8 codeIn) : code(codeIn) { }
	wbcharset_t(int codeIn) : code(codeIn) { }
	bool is_wb8(void) const { return code>1; }
};
const char* wbcharset_t::code_name[]={
  "latin1",
  "CP1250"
};

