typedef int handle_special(const char *);

struct multil_text {
	const char *en;
	const char *cs;
	operator const char *(){return language?cs:en;}
	static int language;
};

/**
 * struct commands_t - table of builtin commands
 *
 * @prefix: String compared with beginning of entered command
 * @action: Command to execute, with rest of the line as textual parameter
 * @help: Short description of what command does
 *
 */

struct command_t {
	const char *prefix;
	handle_special* action;
	multil_text help;
};

extern struct command_t commands_list[];
