/*
 *  Global variables
 */

extern bool disp_attrname;  //zobrazuj jmena atributu (-dn)
extern bool disp_attrtype;  //zobrazuj typ atributu (-dt)
extern bool disp_recnum;    //zobrazuj cislo zaznamu pred kazdym zaznamem (-dr)
extern bool verbose;        //ukecany mod (-v)
extern bool disp_descr;     //zobrazuj popis u nezobrazitelnych atributu
extern bool interactive;    //Jsme interaktivní? 

/* zobrazuj n bytes textoveho atributu, max 64kb (-dl<n>) */
extern int disp_textl;

extern char disp_recsep[8]; //record separator
extern char disp_attrsep[8];//attr separator

/* Mohou prikazy jit pres nekolik radek? (-L) */
extern bool text_may_span;

/* mod zobrazeni:
 *  0 jeden zaznam, jeden atribut na radku (-dm0)
 *  1 jeden zaznam na jeden radek (-dm1)
 */
extern int disp_mode;

extern char ServerName [OBJ_NAME_LEN+1];
extern char LoginName  [OBJ_NAME_LEN+1];
extern char Password   [50];
extern char Application[OBJ_NAME_LEN+1];
extern const char *configfile;
// import parameters:
extern char import_file[256];
extern int  import_flags;
extern char alt_name   [OBJ_NAME_LEN+1];

/* Functions to read parameters */
int read_from_ini();
void read_from_argv(int argc, char **argv); /* exits on error */

/* Function to check if parameters are sufficient - exits if no */
void check_params();

extern "C" {
	int GetPrivateProfileString(const char *section, const char * entry,
				   const char * default_str, char * buf,
				   int buflen, const char * filenames);
	int GetPrivateProfileInt(const char *section,  const char * entry,
			     int default_str, const char * filename);
}

typedef enum {vt_str, vt_int, vt_bool} var_type;

struct var_desc {
	static var_desc internal_variables[];
	static int internal_variables_count;
	const char * const key; /* kyename in the  config file */
	const var_type type; /* bool/str/int */
	void *const location; /* where is it stored? */
	const int size; /* jen pro retezce */
	var_desc(const char *key, const var_type type, void *location, int size):
		key(key), type(type), location(location), size(size){}
	var_desc(const char *key, const var_type type, void *location):
		key(key), type(type), location(location) {}
};

