/****************************************************************************/
/* wbprezex.h - definice pro rozsirenou komunikaci s 602SQL                 */
/* (C) Janus Drozd, 1992, 93, 94, 95, 96, 97, 98, 99, 2000, 01, 02          */
/* verze: 8.0 (32-bit)                                                      */
/****************************************************************************/
#ifndef __WBPREZEX_H__
#define __WBPREZEX_H__

#include "wbapiex.h"

extern "C" {

// object lists:
DllPrezen void WINAPI move_object_names(cdp_t cdp, tcateg cat, HWND hCtrl, int ctrl_type);
DllPrezen void WINAPI move_object_names_ex(cdp_t cdp, tcateg cat, HWND wind, int ctrl_type, int mask, int cond);
#define MV_LIST  0
#define MV_COMBO 1
#define MV_TREE  2
#define MV_MENU  3
#define MV_SLIST 4

// text editor:
#define OPEN_IN_EDCONT 0x0800
DllPrezen HWND WINAPI Edit_text(HWND hParent, tcursnum cursnum, trecnum position, tattrib attr, uns16 index,
				  uns16 sizetype, short x, short y, short xl, short yl);
class editor_type;
DllPrezen editor_type * WINAPI find_editor_by_objnum(HWND hClient, tobjnum objnum, HWND * hWndChild, HWND * hMDIChild, BOOL activate_it, unsigned flags);

// folders:
DllPrezen char * WINAPI Current_folder_name(cdp_t cdp);
DllPrezen void WINAPI Set_object_folder_time(cdp_t cdp, tobjnum objnum, tcateg categ);
DllPrezen tobjnum WINAPI Add_component(cdp_t cdp,
               tcateg categ, ctptr name, tobjnum objnum, BOOL select_it, BOOL noshow = FALSE, BOOL is_encrypted = FALSE, t_folder_index folder = -1);

// entering object names:
DllPrezen BOOL WINAPI  enter_name(HWND hWndParent, const char * capt, char * name);
DllPrezen BOOL WINAPI  is_ident(char * name);
DllPrezen BOOL WINAPI  append_object(cdp_t cdp, HWND hWndParent, tcateg categ, const char * prompt, tobjnum * objnum, char * edt_name);

// message boxes:
DllPrezen void WINAPI  errbox(const char * text);
DllPrezen void WINAPI  infbox(const char * text);
DllPrezen void WINAPI  wrnbox(const char * text);
DllPrezen void WINAPI  unpbox(const char * text);
DllPrezen void WINAPI  box2(const char * text, const char * caption);
DllPrezen void WINAPI  no_memory(void);
DllPrezen tptr WINAPI  sigalloc(unsigned size, uns8 owner);

// other:
DllPrezen void WINAPI ReleaseOle(void);
DllPrezen BOOL WINAPI GKState(WORD key);

DllKernel void WINAPI inval_table_d(cdp_t cdp, tobjnum tb, tcateg cat);
enum t_licence_result { ELIC_OK, ELIC_NOTFOUND, ELIC_TAMPERED, ELIC_CANNOT_WRITE, ELIC_BAD_TYPE, ELIC_INVALID, 
                        ELIC_DLL_MISSING, ELIC_TOO_MANY_LICS, ELIC_ALREADY_STORED, ELIC_NO_RETRIAL, ELIC_BAD_BASE };
DllKernel t_licence_result WINAPI get_licences(int * access, BOOL * internet, BOOL * client, BOOL * server, BOOL * fulltext);

}

#endif // __WBPREZEX_H__
